'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: f_basic_3.inc,v $
'*
'*  $Revision: 1.1.2.3 $
'*
'*  last change: $Author: jsk $ $Date: 2003/11/18 09:19:44 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************************
'*
'* owner : joerg.skottke@sun.com
'*
'* short description : check macro-dialogs / run scripts ( 3. part )
'*
'*******************************************************************************
'*
' #1 tCheckControlsettings              ' check settings of the dialog controls - wrn:10 does not work on status page, when the routine is called more than one times
'*
'\******************************************************************************

testcase tCheckControlsettings
   Dim i as Integer, kControls as Integer
   Dim sFile as String, sControl as String
   Dim lsPropList( 50 ) as String

   '///<b>check if all settings are saved for any control in all applications</b>
   '///open a new doc ( for all applications )

   select case lcase ( gApplication )
      case "writer"  : sFile = gOfficePath + "user\work\w_basic.sxw"
      case "calc"    : sFile = gOfficePath + "user\work\c_basic.sxc"
      case "impress" : sFile = gOfficePath + "user\work\i_basic.sxi"
      case "draw"    : sFile = gOfficePath + "user\work\d_basic.sxd"
   end select

   'DEBUG: Here you can fastly test only one control if you change the 1 - 21.
   'DEBUG: for kControls = 18 to 18 would test only Currency Field.
   for kControls = 1 to 21
      ListAllDelete ( lsPropList() )

      printlog Chr(13) + "   open a new " + gApplication + "-doc"

      '///create a new module for the new document ( named TTModule )
      call hNewDocument
      Call CreateNewModuleForDoc

      '///create a new dialog in BasicIDE
      Kontext "BasicIDE"
      Tabbar.OpenContextMenu
      hMenuSelectNr(1)
      sleep(1)
      hMenuSelectNr(2)
      sleep(2)

      if not DialogWindow.Exists (2) then
         Warnlog "No dialog window is shown!"
         endif

      Kontext "BasicIDE" 'try to grab the IDE, it might have lost focus on Linux

      Kontext "MacroBar"

      '///+tear off controls and insert one control ( for each test only one control )
      printlog "   tear off 'controls'"
      Controls.TearOff
      sleep( 3 )
      
      Kontext "TB_MacroControls"
      if TB_MacroControls.Exists <> TRUE then
         Warnlog "Controls-window is not open!"
      else
         TB_MacroControls.Move ( 50 , 50 )
      endif
      sleep (1)

      '///+the controls are :
      select case kControls
         case 1  :  sControl = "CommandButton"  :  CommandButton.Click
         case 2  :  sControl = "ImageControl"   :  ImageControl.Click
         case 3  :  sControl = "Checkbox"       :  Checkbox.Click
         case 4  :  sControl = "OptionButton"   :  OptionButton.Click
         case 5  :  sControl = "Label"          :  Label.Click
         case 6  :  sControl = "TextField"      :  TextField.Click
         case 7  :  sControl = "ListBox"        :  Listbox.Click
         case 8  :  sControl = "ComboBox"       :  ComboBox.Click
         case 9  :  sControl = "Scrollbar"      :  HScrollBar.Click
         case 10 :  sControl = "Scrollbar"      :  VScrollBar.Click
         case 11 :  sControl = "FrameControl"   :  FrameControl.Click
         case 12 :  sControl = "Progressbar"    :  Progressbar.Click
         case 13 :  sControl = "FixedLine"      :  HLine.Click
         case 14 :  sControl = "FixedLine"      :  VLine.Click
         case 15 :  sControl = "DateField"      :  DateField.Click
         case 16 :  sControl = "TimeField"      :  TimeField.Click
         case 17 :  sControl = "NumericField"   :  NumericField.Click
         case 18 :  sControl = "CurrencyField"  :  CurrencyField.Click
         case 19 :  sControl = "FormattedField" :  FormattedField.Click
         case 20 :  sControl = "PatternField"   :  PatternField.Click
         case 21 :  sControl = "FileControl"    :  FileControl.Click
      end select

      '///+<ol><li>Command button</li>
      '///+<li>Image control</li>
      '///+<li>Check box</li>
      '///+<li>Option button</li>
      '///+<li>Label</li>
      '///+<li>Text field</li>
      '///+<li>List box</li>
      '///+<li>Combo box</li>
      '///+<li>vertical Scroll bar</li>
      '///+<li>horizontal Scroll bar</li>
      '///+<li>Frame control</li>
      '///+<li>Progress bar</li>
      '///+<li>horizontal fixed line</li>
      '///+<li>vertical fixed line</li>
      '///+<li>Date field</li>
      '///+<li>Time field</li>
      '///+<li>Numeric field</li>
      '///+<li>Currency field</li>
      '///+<li>Formatted field</li>
      '///+<li>Pattern field</li>
      '///+<li>File control</li></ol>
      sleep(1)
      printlog "now '" & sControl & "' is tested"
      Call DrawControlOnDialog (35 , 30 , 40 , 35)
      Call DrawControlOnDialog (50 , 50 , 60 , 60)
      sleep(1)
      '///+change all settings for this control
      call hChangeControlSettings(sControl, lsPropList())
      sleep(1)
      '///+close Basic-IDE
      call hCloseDocument
      sleep(1)
      '///+save the document and close it
      call hSpeichernUnterKill (sFile)
      FileClose
      sleep(2)
      '///open the saved document
      call hDateiOeffnen (sFile)
      sleep(1)
      '///+open Basic-IDE for this file
      call SelectTheLastModule ( TRUE , FALSE )
      Bearbeiten.Click
      Sleep (2)

      '///+open the dialog window
      Kontext "BasicIDE"
      for i=1 to 20
         Tabbar.MouseDown ( 5*i , 50 )
         Tabbar.MouseUp ( 5*i , 50 )
         if DialogWindow.Exists(1) then i=100
      next i

      Kontext "MacroBar"
       if MacroBar.Exists(2) then
           '///+tear off controls toolbox
           printlog "   tear off 'controls'"
           Controls.TearOff
           sleep(2)
       else
           QAErrorLog "Is the Macro Dialog window really visible? Exit the testcase!"
           Call hCloseDocument
           Call hCloseDocument        
       end if
       
      Kontext "TB_MacroControls"
      if TB_MacroControls.Exists(1) <> TRUE then
         Warnlog "Controls-window is not open!"
      else
         TB_MacroControls.Move ( 50 , 50 )
      endif
      Sleep (1)
      '///+activate select mode and the properties
      printlog "   activate select mode"
      SelectMode.Click
      sleep( 1 )

      Kontext "BasicIDE"
      DialogWindow.MouseDown ( 45 , 45 )
      DialogWindow.MouseMove ( 65 , 65 )
      DialogWindow.MouseUp   ( 65 , 65 )
      sleep( 2 )

      '///+check all changed settings
      call hCheckControlSettings ( sControl, lsPropList( ) )

      '///+close Basic IDE and the document
      Call hCloseDocument
      Call hCloseDocument

   '///<b>next control</b>
   next kControls

endcase
