'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: t_doc1.inc,v $
'*
'*  $Revision: 1.6 $
'*
'*  last change: $Author: tbo $ $Date: 2003/11/27 18:20:31 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/**************************************************************************************
'*
'* owner : thorsten.bosbach@sun.com
'*
'* short description : Global Routines for Document Handling
'*
'***************************************************************************************
' #1 hCloseAndLooseDocument 'wrn:0|err:0 'Closes a document and accepts the loose of content.
' #1 hCreateLabels
' #1 hCreateBusinessCards
' #1 hGetDefaultFiltername
' #1 hNewDocument
' #1 hNeuesDokument
' #1 hCloseDocument
' #1 hCloseAndLooseDocument
' #1 hDokumentSchliessen
' #1 gMouseClick
' #1 gMouseDoubleClick
' #1 gMouseMove
' #1 gMouseDown
' #1 gMouseMove2
' #1 gMouseUp
' #1 hTypeKeys
'\*************************************************************************************

sub hNewDocument ( optional bANewDoc )
'/// hNewDocument : open a new document dependent on 'gApplication' ///'
   gApplication = Ucase ( gApplication )

   if IsMissing ( bANewDoc ) <> TRUE then
      if bANewDoc = TRUE then
         gNoNewDoc = FALSE
      else
         gNoNewDoc = TRUE
      end if
   end if

   select case gApplication
      case "WRITER",  "TEXTDOKUMENT"    : Kontext "DocumentWriter"
                                          if gNoNewDoc = TRUE then
                                             FileOpen "FileName", "private:factory/swriter"
                                          else
                                             FileOpen "FileName", "private:factory/swriter", "FrameName", "_default"
                                          end if
      case "CALC", "TABELLENDOKUMENT"   : Kontext "DocumentCalc"
                                          if gNoNewDoc = TRUE then
                                             FileOpen "FileName", "private:factory/scalc"
                                          else
                                             FileOpen "FileName", "private:factory/scalc", "FrameName", "_default"
                                          end if
      case "IMPRESS", "PRAESENTATION"   : Kontext "DocumentImpress"
                                          if gNoNewDoc = TRUE then
                                             FileOpen "FileName", "private:factory/simpress"
                                          else
                                             FileOpen "FileName", "private:factory/simpress", "FrameName", "_default"
                                             Kontext "AutoPilotPraesentation1"
                                             if AutoPilotPraesentation1.Exists (2) then
                                                Printlog "------------------------------The Impress-Autopilot was active------------------"
                                                MitAutopilotStarten.Check             ' opposite of the checkboxs' title
                                                AutoPilotPraesentation1.OK
                                                Sleep 2
                                                Kontext "SeitenLayout"
                                                SeitenLayout.Cancel
                                             end if
                                             Kontext "DocumentImpress"
                                             Sleep 2
                                          end if
      case "DRAW", "ZEICHNUNG"          : Kontext "DocumentDraw"
                                          if gNoNewDoc = TRUE then
                                             FileOpen "FileName", "private:factory/sdraw"
                                          else
                                             FileOpen "FileName", "private:factory/sdraw", "FrameName", "_default"
                                          end if
      case "MASTERDOC", "GLOBALDOKUMENT", "GLOBALDOC" :
                                          Kontext "DocumentMasterDoc"
                                          if gNoNewDoc = TRUE then
                                             FileOpen "FileName", "private:factory/swriter/GlobalDocument"
                                          else
                                             FileOpen "FileName", "private:factory/swriter/GlobalDocument", "FrameName", "_default"
                                          end if
                                          Kontext "Navigator"
                                          sleep (1)
                                          if Navigator.Exists(5) then Navigator.Close
                                          Kontext "DocumentMasterDoc"
      case "MATH", "FORMEL"             : Kontext "DocumentMath"
                                          if gNoNewDoc = TRUE then
                                             FileOpen "FileName", "private:factory/smath"
                                          else
'                                             FileOpen "FileName", "private:factory/smath", "FrameName", "_blank"
                                             FileOpen "FileName", "private:factory/smath", "FrameName", "_default"
                                          end if
                                          Kontext "DocumentMath"
      case "HTML", "HTMLDOKUMENT"       : Kontext "DocumentWriterWeb"
                                          if gNoNewDoc = TRUE then
                                             FileOpen "FileName", "private:factory/swriter/web"
                                          else
                                             FileOpen "FileName", "private:factory/swriter/web", "FrameName", "_default"
                                          end if
                                          Kontext "DocumentWriterWeb"
      case else             : WarnLog "hNewDocument: No Applikation named '" + gApplication + "' exists in this routine!"
   end select
   Sleep 2
end sub

sub hNeuesDokument ( optional bv )
'///  DEPRACTED: hNeuesDokument == hNewDocument ///'
      Call hNewDocument ( bv )
end sub

function hCreateLabels() as Boolean
'/// hCreateLabels : open the tab-dialog for making a new lable (file/new/lable) ///'
    FileOpen "FileName", "private:factory/swriter?slot=21051", "FrameName", "_default"
    Sleep (2)
   Kontext
    Active.Setpage TabEtiketten
    Kontext "TabEtiketten"
   if Not TabEtiketten.Exists then
    Warnlog "Dialog for Labels is not up!"
    hCreateLabels = False
   else
    hCreateLabels = True
   endif
   Sleep (2)
end function

function hCreateBusinessCards() as Boolean
'/// hCreateBusinessCards : open the tab-dialog for making a new business card (file/new/business cards) ///'
   FileOpen "FileName", "private:factory/swriter?slot=21052", "FrameName", "_default"   
   Sleep (2)
   Kontext
    Active.Setpage TabEtikettenMedium
    Kontext "TabEtikettenMedium"
   if Not TabEtikettenMedium.Exists then
    Warnlog "Dialog for BusinessCards is not up!"
    hCreateBusinessCards = False
   else
    hCreateBusinessCards = True
   endif
   Sleep (2)
end function

sub hCloseDocument ( optional bANewDoc )
'/// hCloseDocument : close a document without saving ///'
'///+ all documents will be closed without saving ///'
   Dim sFehler$

   if IsMissing ( bANewDoc ) <> TRUE then
      if bANewDoc = TRUE then
         gNoNewDoc = FALSE
      else
         gNoNewDoc = TRUE
      end if
   end if

   ' if no new document was created, it isn't closed
   if gNoNewDoc = TRUE then
      exit sub        
   end if

   Sleep 3
   try
      FileClose
   catch
      Exceptlog
      exit sub
   endcatch

   Sleep 1
   Kontext "Active"
   if Active.Exists(2) then
      try
         Active.No
      catch
         Active.Click ( 202 )
      endcatch
   end if
   Sleep (2)
end sub

sub hCloseAndLooseDocument
'/// <i>hCloseAndLooseDocument</i>
'///+ Closes a (modified) document and the verify dialog will be answered
'///+ with yes. That means you want to loose format information or you want
'///+ to loose the document!
   Dim sFehler$

   try
      FileClose
    catch
      Exceptlog
      exit sub
   endcatch
   sleep (2)
   Kontext
   if Active.Exists(2) then Active.Yes
end sub

sub hDokumentSchliessen ( optional bv )
'/// DEPRACTED: hDokumentSchliessen == hCloseDocument ///'
      Call hCloseDocument ( bv )
end sub

sub gMouseClick ( X%, Y% )
'/// gMouseClick ( x_Position, y-Position ) : make a mouseclick on the document (dependent on 'gApplication') ///'
   gApplication = UCase ( gApplication )

   select case gApplication
      case "DESKTOP" :
              Kontext "Desktop"
              autoexecute = false
              Desktop.MouseDown ( X%, Y% )
              Desktop.MouseUp ( X%, Y% )
              autoexecute = true
      case "CALC" :
              Kontext "DocumentCalc"
              autoexecute = false
              DocumentCalc.MouseDown ( X%, Y% )
              DocumentCalc.MouseUp ( X%, Y% )
              autoexecute = true
      case "DRAW" :
              Kontext "DocumentDraw"
              autoexecute=false
              DocumentDraw.MouseDown ( X%, Y% )
              DocumentDraw.MouseUp ( X%, Y% )
              autoexecute=true
      case "WRITER" :
              Kontext "DocumentWriter"
              autoexecute=false
              DocumentWriter.MouseDown ( X%, Y% )
              DocumentWriter.MouseUp ( X%, Y% )
              autoexecute=true
      case "HTMLDOKUMENT" :
              Kontext "DocumentWriterWeb"
              autoexecute=false
              DocumentWriterWeb.MouseDown ( X%, Y% )
              DocumentWriterWeb.MouseUp ( X%, Y% )
              autoexecute=true
      case "MASTERDOC" :
              Kontext "DocumentMasterDoc"
              autoexecute=false
              DocumentMasterDoc.MouseDown ( X%, Y% )
              DocumentMasterDoc.MouseUp ( X%, Y% )
              autoexecute=true
      case "IMPRESS" :
              Kontext "DocumentImpress"
              autoexecute=false
              DocumentImpress.MouseDown ( X%, Y% )
              DocumentImpress.MouseUp ( X%, Y% )
              autoexecute=true
      case "MATH" :
              Kontext "DocumentMath"
              autoexecute=false
              DocumentMath.MouseDown ( X%, Y% )
              DocumentMath.MouseDown ( X%, Y% )
              autoexecute=true
      case "CHART" :
              Kontext "DocumentChart"
              autoexecute=false
              DocumentChart.MouseDown ( X%, Y% )
              DocumentChart.MouseUp ( X%, Y% )
              autoexecute=true
   end select
   sleep (2)
end sub

sub gMouseDoubleClick ( X%, Y% )
'/// gMouseDoubleClick ( x_Position, y-Position ) : make a mouse-doubleclick on the document ( dependent on 'gApplication' ) ///'
   gApplication = UCase ( gApplication )

   select case gApplication
      case "CALC" :
              Kontext "DocumentCalc"
              DocumentCalc.MouseDoubleClick ( X%, Y% )
      case "DRAW" :
              Kontext "DocumentDraw"
              DocumentDraw.MouseDoubleClick ( X%, Y% )
      case "DESKTOP" :
              Kontext "Desktop"
              Desktop.MouseDoubleClick ( X%, Y% )
      case "WRITER" :
              Kontext "DocumentWriter"
              DocumentWriter.MouseDoubleClick ( X%, Y% )
      case "HTMLDOKUMENT" :
              Kontext "DocumentWriterWeb"
              DocumentWriterWeb.MouseDoubleClick ( X%, Y% )
      case "MASTERDOC" :
              Kontext "DocumentMasterDoc"
              DocumentMasterDoc.MouseDoubleClick ( X%, Y% )
      case "IMPRESS" :
              Kontext "DocumentImpress"
              DocumentImpress.MouseDoubleClick ( X%, Y% )
      case "MATH" :
              Kontext "DocumentMath"
              DocumentMath.MouseDoubleClick ( X%, Y% )
   end select
   Sleep (2)
end sub

sub gMouseMove ( BeginX%, BeginY%, EndX%, EndY% )
'/// gMouseMove ( BeginX, BeginY, EndX, EndY ) : make a mousemove trom Bx,By to Ex,Ey on the document ( dependent on 'gApplication' ) ///'
   gApplication = UCase ( gApplication )

   select case gApplication
      case "CALC" :
              Kontext "DocumentCalc"
              DocumentCalc.MouseDown ( BeginX%, BeginY% )
              DocumentCalc.MouseMove ( EndX%, EndY%)
              DocumentCalc.MouseUp ( EndX%, EndY% )
      case "DRAW" :
              Kontext "DocumentDraw"
              DocumentDraw.MouseDown ( BeginX%, BeginY% )
              DocumentDraw.MouseMove ( EndX%, EndY% )
              DocumentDraw.MouseUp ( EndX%, EndY% )
      case "WRITER" :
              Kontext "DocumentWriter"
              DocumentWriter.MouseDown ( BeginX%, BeginY% )
              DocumentWriter.MouseMove ( EndX%, EndY%)
              DocumentWriter.MouseUp ( EndX%, EndY% )
      case "HTMLDOKUMENT" :
              Kontext "DocumentWriterWeb"
              DocumentWriterWeb.MouseDown ( BeginX%, BeginY% )
              DocumentWriterWeb.MouseMove ( EndX%, EndY%)
              DocumentWriterWeb.MouseUp ( EndX%, EndY% )
      case "MASTERDOC" :
              Kontext "DocumentMasterDoc"
              DocumentMasterDoc.MouseDown ( BeginX%, BeginY% )
              DocumentMasterDoc.MouseMove ( EndX%, EndY%)
              DocumentMasterDoc.MouseUp ( EndX%, EndY% )
      case "IMPRESS" :
              Kontext "DocumentImpress"
              DocumentImpress.MouseDown ( BeginX%, BeginY% )
              DocumentImpress.MouseMove ( EndX%, EndY%)
              DocumentImpress.MouseUp ( EndX%, EndY% )
      case "MATH" :
              Kontext "DocumentMath"
              DocumentMath.MouseDown ( BeginX%, BeginY% )
              DocumentMath.MouseMove ( EndX%, EndY%)
              DocumentMath.MouseDown ( EndX%, EndY% )
   end select
   Sleep (2)
end sub

sub gMouseDown ( BeginX%, BeginY% )
'/// gMouseDown ( x_Position, y-Position ) : make a mousedown on the document (dependent on 'gApplication') ///'
'///+ DON'T FORGETT to call gMouseUp !  ///'
   gApplication = UCase ( gApplication )

   select case gApplication
      case "CALC" :
              Kontext "DocumentCalc"
              DocumentCalc.MouseDown ( BeginX%, BeginY% )
      case "DRAW" :
              Kontext "DocumentDraw"
              DocumentDraw.MouseDown ( BeginX%, BeginY% )
      case "WRITER" :
              Kontext "DocumentWriter"
              DocumentWriter.MouseDown ( BeginX%, BeginY% )
      case "HTMLDOKUMENT" :
              Kontext "DocumentWriterWeb"
              DocumentWriterWeb.MouseDown ( BeginX%, BeginY% )
      case "MASTERDOC" :
              Kontext "DocumentMasterDoc"
              DocumentMasterDoc.MouseDown ( BeginX%, BeginY% )
      case "IMPRESS" :
              Kontext "DocumentImpress"
              DocumentImpress.MouseDown ( BeginX%, BeginY% )
      case "MATH" :
              Kontext "DocumentMath"
              DocumentMath.MouseDown ( BeginX%, BeginY% )
   end select
   Sleep (2)
end sub

sub gMouseMove2 ( EndX%, EndY% )
'/// gMouseMove2 ( x_Position, y-Position ) : move the pointer to position on the document (dependent on 'gApplication') ///'
   gApplication = UCase ( gApplication )

   select case gApplication
      case "CALC" :
              Kontext "DocumentCalc"
              DocumentCalc.MouseMove ( EndX%, EndY%)
      case "DRAW" :
              Kontext "DocumentDraw"
              DocumentDraw.MouseMove ( EndX%, EndY% )
      case "WRITER" :
              Kontext "DocumentWriter"
              DocumentWriter.MouseMove ( EndX%, EndY%)
      case "HTMLDOKUMENT" :
              Kontext "DocumentWriterWeb"
              DocumentWriterWeb.MouseMove ( EndX%, EndY%)
      case "MASTERDOC" :
              Kontext "DocumentMasterDoc"
              DocumentMasterDoc.MouseMove ( EndX%, EndY%)
      case "IMPRESS" :
              Kontext "DocumentImpress"
              DocumentImpress.MouseMove ( EndX%, EndY%)
      case "MATH" :
              Kontext "DocumentMath"
              DocumentMath.MouseMove ( EndX%, EndY%)
   end select
   Sleep (2)
end sub

sub gMouseUp ( EndX%, EndY% )
'/// gMouseUp ( x_Position, y-Position ) : make a release button on the document (dependent on 'gApplication') ///'
   gApplication = UCase ( gApplication )

   select case gApplication
      case "CALC" :
              Kontext "DocumentCalc"
              DocumentCalc.MouseUp ( EndX%, EndY% )
      case "DRAW" :
              Kontext "DocumentDraw"
              DocumentDraw.MouseUp ( EndX%, EndY% )
      case "WRITER" :
              Kontext "DocumentWriter"
              DocumentWriter.MouseUp ( EndX%, EndY% )
      case "HTMLDOKUMENT" :
              Kontext "DocumentWriterWeb"
              DocumentWriterWeb.MouseUp ( EndX%, EndY% )
      case "MASTERDOC" :
              Kontext "DocumentMasterDoc"
              DocumentMasterDoc.MouseUp ( EndX%, EndY% )
      case "IMPRESS" :
              Kontext "DocumentImpress"
              DocumentImpress.MouseUp ( EndX%, EndY% )
      case "MATH" :
              Kontext "DocumentMath"
              DocumentMath.MouseDown ( EndX%, EndY% )
   end select
   Sleep (2)
end sub

function hGetDefaultFiltername
'/// hGetDefaultFiltername () : to get the default filtername for each application ( dependent on 'gApplication' ) ///'
   select case gApplication
      case "WRITER",  "TEXTDOKUMENT"    : hGetDefaultFiltername = "StarWriter 5.0"
      case "CALC", "TABELLENDOKUMENT"   : hGetDefaultFiltername = "StarCalc 5.0"
      case "IMPRESS", "PRAESENTATION"   : hGetDefaultFiltername = "StarImpress 5.0"
      case "DRAW", "ZEICHNUNG"          : hGetDefaultFiltername = "StarDraw 5.0"
      case "GLOBALDOC", "GLOBALDOKUMENT":
         select case iSprache
            case 01, 31 : hGetDefaultFiltername = "StarWriter 5.0/Master Document"
            case 03     : hGetDefaultFiltername = "StarWriter 5.0/Documento-mestre"
            case 33     : hGetDefaultFiltername = "StarWriter 5.0/Document maître"
            case 34     : hGetDefaultFiltername = "StarWriter 5.0/Documento maestro"
            case 39     : hGetDefaultFiltername = "StarWriter 5.0/Documento master"
            case 45     : hGetDefaultFiltername = "StarWriter 5.0/Hoveddokument"
            case 46     : hGetDefaultFiltername = "StarWriter 5.0/Samlingsdokument"
            case 48     : hGetDefaultFiltername = "StarWriter 5.0/Dokument globalny"
            case 49     : hGetDefaultFiltername = "StarWriter 5.0/Globaldokument"
            case else   : hGetDefaultFiltername = "StarWriter 5.0/Globaldokument"
               Warnlog "hGetDefaultFiltername : No filtername available for the languagecode " + iSprache
         end select
     case "CHART", "DIAGRAMM"          : hGetDefaultFiltername = "StarChart 5.0"
     case "MATH", "FORMEL"             : hGetDefaultFiltername = "StarMath 5.0"
     case "HTML", "HTMLDOKUMENT"       : hGetDefaultFiltername = "HTML"
   end select
end function

sub hTypeKeys ( OutputText , optional iLoop as Integer )
'/// hTypeKeys  ( OutputText , optional iLoop as Integer ): type the keys in 'outputtext' 'iLoop' times ///'
   Dim i as integer
   
   If IsMissing(iLoop) = True then iLoop = 1
   For i = 1 to iLoop
       Select Case Ucase(gApplication)
          Case "WRITER"
            Kontext "DocumentWriter"
            DocumentWriter.TypeKeys OutputText
          Case "MASTERDOC"
            Kontext "DocumentMasterDoc"
            DocumentMasterDoc.TypeKeys OutputText
          Case "HTMLDOKUMENT"
            Kontext "DocumentWriterWeb"
            DocumentWriterWeb.TypeKeys OutputText
          case "CALC" :
            Kontext "DocumentCalc"
            DocumentCalc.TypeKeys OutputText
          case "DRAW"
            Kontext "DocumentDraw"
            DocumentDraw.TypeKeys OutputText
          case "IMPRESS"
            Kontext "DocumentImpress"
            DocumentImpress.TypeKeys OutputText
          case "MATH" :
            Kontext "DocumentMath"
            DocumentMath.TypeKeys OutputText
       end select
       wait 500
   next i
end sub

