'encoding UTF-8  Do not remove or change this line!
'*************************************************************************
'*
'*  $RCSfile: w_006_.inc,v $
'*
'*  $Revision: 1.2.2.3 $
'*
'*  last change: $Author: hde $ $Date: 2004/02/25 09:14:23 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/***********************************************************************
'*
'* owner : helge.delfs@sun.com
'*
'* short description : Put description here
'*
'\***********************************************************************


sub w_006_
    printLog Chr(13) + "--------- Tools Menu (w_006_.inc) ----------"

    Call tToolsSpellcheck
    Call tToolsThesaurus
    Call tToolsHyphenation
    Call tToolsAutocorrectAutoformat
    Call tToolsOutlineNumbering
    Call tToolsLineNumbering
    Call tToolsFootnotes
    Call tToolsGallery
    Call tToolsBibliographyDatabase
    Call tToolsDataSources
    Call tToolsMailMerge
    Call tToolsTextInTables
    Call tToolsSort
    Call tToolsCalculate
    Call tToolsUpdate
'   Call tToolsMacro
    Call tToolsConfigure
    Call tToolsOptionsTest        ' inc\desktop\optionen.inc

end sub

' -------------------------------------------

testcase tToolsSpellcheck
    PrintLog "- Tools / Spellcheck"
    Dim i as integer, DieDatei as string
    '/// Check if dictionary has been installed to "share/dict/[OfficeLanguage]-spell.dat ///
    Printlog "- Checking Dictionary-Files"
    select case iSprache
        case 01 : DieDatei = "01-44-spell.dat"
        case 81 : Printlog "- No Spellcheck in Japanese!"
                     goto endsub
        case 82 : Printlog "- No Spellcheck in Korean!"
                     goto endsub
        case 86 : Printlog "- No Spellcheck in Chinese (simplified)!"
                     goto endsub
        case 88 : Printlog "- No Spellcheck in Chinese (traditional)!"
                     goto endsub
        case else : DieDatei =  str$(iSprache) + "-spell.dat"
    end select
    if gNetzInst = TRUE then
        DieDatei = Convertpath (gNetzOfficePath + "share\dict\" + trim$(DieDatei))
    else
        DieDatei = Convertpath (gOfficePath + "share\dict\" + trim$(DieDatei))
    endif
    if Dir ( DieDatei ) = "" then
        Warnlog "Spellcheck-File: " + DieDatei + " not found!"
        goto endsub
    else
        Printlog "Dictionary has been installed : " + DieDatei
    end if

    Call hNewDocument
    '/// Open new document ///
    Call wDokSchreiben ("Dies ist ein Rechtschreibtexxxxt<Home>")
    '/// Insert some faulty text ///
    ToolsSpellcheckCheckWriter
    '/// Tools / Spellcheck / Check ///
    wait 500
    Kontext "Active"
    if Active.Exists then
        if Active.GetRT = 304 then
            try
                Active.Yes  ' Start from beginning ?
                if Active.exists then
                    if Active.GetRT = 304 then Active.Ok
                    Warnlog "Dialog 'Spellcheck' not up!"
                    Call hCloseDocument
                    goto endsub
                endif
            catch
                Active.Ok
                Warnlog "Dialog 'Spellcheck' not up!"
                Call hCloseDocument
                goto endsub
            endcatch
        endif
    endif
    '/// Spellcheck dialog has to come up ///
    Kontext "Rechtschreibung"
    DialogTest ( Rechtschreibung )
    '/// Click 'Options' ///
    Optionen.Click
    Wait 500
    kontext "TabLinguistik"
    DialogTest ( TabLinguistik )
    '/// Step through all options in list and if 'Edit' is enabled click 'Edit' ///
    for i = 1 to 12
        Optionen.TypeKeys "<Down>"
        if OptionenBearbeiten.IsEnabled then
            OptionenBearbeiten.Click
            wait 500
            Kontext "SilbentrennungOptionen"
            DialogTest ( SilbentrennungOptionen )
            SilbentrennungOptionen.Cancel
            i = 13
        endif
    next i
    '/// Close 'Options' dialog ///
    Kontext "TabLinguistik"
    TabLinguistik.Close
    wait 500
    Kontext "Rechtschreibung"
    '/// Click 'Thesaurus' on Spellcheck dialog ///
    Thesaurus.Click

    Kontext "Thesaurus"
    DialogTest(Thesaurus)
    '/// Select 'Language' on Thesaurus dialog ///
    Sprache.Click
    wait 500
    Kontext "SpracheAuswaehlen"
    DialogTest (SpracheAuswaehlen)
    SpracheAuswaehlen.Cancel
    '/// Close 'Language' dialog ///
    wait 500
    Kontext "Thesaurus"
    Thesaurus.Cancel
    '/// Close 'Thesaurus' dialog ///
    Kontext "Rechtschreibung"
    Rechtschreibung.Close
    '/// Close 'Spellcheck' dialog ///
    wait 500
    Call hCloseDocument
    '/// Close active document ///

endcase

' -------------------------------------------

testcase tToolsThesaurus
    PrintLog "- Tools / Thesaurus"
    Dim DieDatei as string
    select case iSprache
        case 07 : Printlog "- No Thesaurus in Russian!"
                     goto endsub
        case 48 : Printlog "- No Thesaurus in Polish!"
                     goto endsub
        case 55 : Printlog "- No Thesaurus in Portuguese/Brazilian!"
                     goto endsub
		case 81 : Printlog "- No Thesaurus in Japanese!"
                     goto endsub
        case 82 : Printlog "- No Thesaurus in Korean!"
                     goto endsub
        case 86 : Printlog "- No Thesaurus in Chinese (simplified)!"
                     goto endsub
        case 88 : Printlog "- No Thesaurus in Chinese (traditional)!"
                     goto endsub
    end select
    '/// Check if thesaurus-file has been installed in share/dict/[OfficeLanguage]_thes.dat ///
    if iSprache <> 1 then
        DieDatei =  str$(iSprache) + "_thes.dat"
    else
        DieDatei =  "01_thes.dat"
    endif
    if gNetzInst = TRUE then
        DieDatei = Convertpath (gNetzOfficePath + "share\dict\" + trim$(DieDatei))
    else
        DieDatei = Convertpath (gOfficePath + "share\dict\" + trim$(DieDatei))
    endif
    if Dir ( DieDatei ) = "" then
        Warnlog "Thesaurus-File: " + DieDatei + " not found!"
        goto endsub
    else
        Printlog "Dictionary has been installed : " + DieDatei
    end if

    Call hNewDocument
    '/// Open new document ///
    Call wDokSchreiben ("Dies ist ein Rechtschreibtexxt<Home>")
    '/// Insert a faulty text ///
    ToolsThesaurusWriter
    Kontext "Active"
    if Active.Exists then
        Active.Ok
        Warnlog "Dialog 'Thesaurus' not up!"
        Call hCloseDocument
        goto endsub
    endif

    Kontext "Thesaurus"
    DialogTest ( Thesaurus )
    '/// In 'Thesaurus' dialog click 'Language' ///
    Sprache.Click
    Kontext "SpracheAuswaehlen"
    DialogTest ( SpracheAuswaehlen )
    '/// Close 'Language' dialog ///
    SpracheAuswaehlen.Cancel
    Kontext "Thesaurus"
    Thesaurus.Cancel
    '/// Close 'Thesaurus' dialog ///
    Call hCloseDocument
    '/// Close active document ///

endcase

' -------------------------------------------

testcase tToolsHyphenation
    Dim DieDatei as string,LingFile as string
    PrintLog "- Tools / Hyphenation"
    select case iSprache
        case 1,01 : LingFile = "01-44-hyph.dat"
                     DieDatei = ConvertPath( gTesttoolpath + "writer\input\linguistik\001.sxw" )
        case 81 : Printlog "- No Hyphenation in Japanese!"
                     goto endsub
        case 82 : Printlog "- No Hyphenation in Korean!"
                     goto endsub
        case 86 : Printlog "- No Hyphenation in Chinese (simplified)!"
                     goto endsub
        case 88 : Printlog "- No Hyphenation in Chinese (traditional)!"
                     goto endsub
        case else : DieDatei = ConvertPath( gTesttoolpath + "writer\input\linguistik\0" + trim$(str$(iSprache)) + ".sxw" )
                        LingFile = str$(iSprache) + "-hyph.dat"
    end select
    '/// Check if Hyphenation-File is installed in "/share/dict/[OfficeLanguage]-hyph.dat" ///
    if gNetzInst = TRUE then
        LingFile = Convertpath (gNetzOfficePath + "share\dict\" + trim$(LingFile))
    else
        LingFile = Convertpath (gOfficePath + "share\dict\" + trim$(LingFile))
    endif
    if Dir ( LingFile ) = "" then
        Warnlog "Hyphenation-File: " + LingFile + " not found!"
        goto endsub
    else
        Printlog "Dictionary has been installed : " + LingFile
    end if

    if hFileExists(DieDatei) = False then
        Warnlog "No defined Errortext for language: " + isprache + "! Exit!"
        goto endsub
    endif

    Select Case gApplication
        Case "WRITER"
            Call hDateiOeffnen ( DieDatei )

        Case "MASTERDOC"
            if wInsertDocumentinMasterDoc(DieDatei) = False then
                Warnlog "Loading document did not work!"
                goto endsub
            else
                Call hNewDocument
                '/// Open new document ///
                EditPaste
            endif

        Case "HTMLDOKUMENT"
            printlog "- No Hyphenation in WriterWeb!"
            goto endsub
    end select

    '/// "Insert file 'writer\input\linguistik\0" + [OfficeLanguage] + ".sxw" ///
    Sleep 5
    Call wDokSchreiben ("<Mod1 Home>")

    ToolsHyphenate
    '/// Tools / Hyphenate ///
    Kontext "Active"
    try
        Active.Yes
    catch
    endcatch
    if Active.Exists then
        if Active.GetRT = 304 then
            Active.Ok
            ' Force pagesize change to bringup Hyphenation-dialog
            FormatPageWriter
            Kontext
            active.SetPage TabSeite
            Kontext "TabSeite"
            Breite.Settext "15"
            TabSeite.Ok
            Sleep 1
            ToolsHyphenate
        endif
    endif

    Kontext "Silbentrennung"
    '/// Close upcoming 'Hyphenation' dialog ///
    if Silbentrennung.Exists then
        Call DialogTest ( Silbentrennung )
        Silbentrennung.Cancel
    else
        Warnlog "Dialog 'Hyphenation' not up!"
        Kontext "Active"
        if Active.Exists then
            try
                Active.Ok
            catch
            endcatch
        endif
    endif

    Call hCloseDocument
    '/// Close active document ///
    if gApplication = "MASTERDOC" then Call hCloseDocument
endcase

' -------------------------------------------

testcase tToolsAutocorrectAutoformat
    PrintLog "- Tools / Autocorrect / Autoformat"
    Dim i as integer

    Call hNewDocument
    '/// Open new document ///
    ToolsAutoCorrect
    '/// Tools / Autocorrect/Autoformat ///

    Kontext "Active"
    if Active.Exists then
        if Active.GetRT = 304 then
            Warnlog Active.Gettext
            Active.Ok
        endif
    endif

    '/// Step through all tabpages ///
    Kontext
    active.SetPage TabErsetzung
    Kontext "Active"
    if Active.Exists then
        if Active.GetRT = 304 then
            Warnlog Active.Gettext
            Active.Ok
        endif
    endif
    Kontext "TabErsetzung"
    Call DialogTest ( TabErsetzung )

    Kontext
    active.SetPage TabAusnahmen
    Kontext "Active"
    if Active.Exists then
        if Active.GetRT = 304 then
            Warnlog Active.Gettext
            Active.Ok
        endif
    endif
    Kontext "TabAusnahmen"
    Call DialogTest ( TabAusnahmen )

    Kontext
    active.SetPage TabOptionenAutokorrektur
    Kontext "TabOptionenAutokorrektur"
    Call DialogTest ( TabOptionenAutokorrektur )
    '/// Step through all options in list ///
    '/// Tabpage Options: With entry 11 button 'Edit' should be enabled ///
    Einstellungen.TypeKeys "<Down>",11
    Wait 500
    if Bearbeiten.IsEnabled then
        Bearbeiten.Click
        Kontext "Sonderzeichen"
        DialogTest (Sonderzeichen)
        Sonderzeichen.Cancel
    else
        Warnlog "- Button 'Edit' on Entry 11 disabled!"
    endif

    Kontext "TabOptionenAutokorrektur"
    '/// Tabpage Options: With entry 17 button 'Edit' should be enabled ///
    Einstellungen.TypeKeys "<Down>",6
    Wait 500
    if Bearbeiten.IsEnabled then
        Bearbeiten.Click
        Kontext "Sonderzeichen"
        DialogTest (Sonderzeichen)
        Sonderzeichen.Cancel
    else
        Warnlog "- Button 'Edit' on Entry 16 disabled!"
    endif

    Kontext "TabOptionenAutokorrektur"
    '/// Tabpage Options: With entry 19 button 'Edit' should be enabled ///
    Einstellungen.TypeKeys "<Down>",2
    Wait 500
    if Bearbeiten.IsEnabled then
        Bearbeiten.Click
        Kontext "Zusammenfassen"
        DialogTest (Zusammenfassen)
        Zusammenfassen.Cancel
        Kontext "TabOptionenAutokorrektur"
    else
        Warnlog "- Button 'Edit' on Entry 18 disabled!"
    endif

    Kontext
    active.SetPage TabTypografisch
    Kontext "TabTypografisch"
    EinfachWortAnfang.Click
    Kontext "Sonderzeichen"
    Call Dialogtest2 ( Sonderzeichen, 1 )
    Sonderzeichen.Cancel

    Kontext "TabTypografisch"
    EinfachWortEnde.Click
    Kontext "Sonderzeichen"
    Call Dialogtest2 ( Sonderzeichen, 2 )
    Sonderzeichen.Cancel

    Kontext "TabTypografisch"
    EinfachStandard.Click

    Kontext "TabTypografisch"
    DoppeltWortAnfang.Click
    Kontext "Sonderzeichen"
    Call Dialogtest2 ( Sonderzeichen, 3 )
    Sonderzeichen.Cancel

    Kontext "TabTypografisch"
    DoppeltWortEnde.Click
    Kontext "Sonderzeichen"
    Call Dialogtest2 ( Sonderzeichen, 4 )
    Sonderzeichen.Cancel

    Kontext "TabTypografisch"
    DoppeltStandard.Click

    Kontext
    Active.Setpage TabWortergaenzung
    Kontext "TabWortergaenzung"
    Call DialogTest ( TabWortergaenzung )
    '/// Close Autocorrect dialg ///

    TabWortergaenzung.Cancel

    Call hCloseDocument
    '/// Close active document ///
endcase

' -------------------------------------------

testcase tToolsOutlineNumbering
    PrintLog "- Tools / Outline Numbering"

    Call hNewDocument
    '/// Open new document ///
    ToolsOutlineNumbering
    '/// Tools / Outline Numbering ///
    Kontext
    Active.SetPage TabKapitelnumerierung
    Kontext "TabKapitelnumerierung"
    Call DialogTest ( TabKapitelnumerierung )

    Kontext
    Active.SetPage TabPositionKapitelnumerierung
    Call DialogTest ( TabPositionKapitelnumerierung )
    '/// Step through tabpages and close dialog ///

    TabPositionKapitelnumerierung.Cancel
    Call hCloseDocument
    '/// Close active document ///

endcase

' -------------------------------------------

testcase tToolsLineNumbering
    PrintLog "- Tools / Line Numbering"

    Call hNewDocument
    '/// Open new document ///
    ToolsLineNumbering
    '/// Tools / Line Numbering ///
    Kontext "TabZeilennumerierung"
    '/// Check checkbox 'Show numbering' ///
    Einschalten.Check
    Call DialogTest ( TabZeilennumerierung )
    '/// Close dialog ///
    TabZeilennumerierung.Cancel
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase tToolsFootnotes
    PrintLog "- Tools / Footnotes"

    Call hNewDocument
    '/// Open new document ///
    ToolsFootnote
    '/// Tools / Footnotes ///
    Kontext
    Active.Setpage TabFussnoten
    Kontext "TabFussnoten"
    DialogTest ( TabFussnoten )
    '/// Step through all tabpages ///

    Kontext
    Active.SetPage TabEndnoten
    Kontext "TabEndnoten"
    DialogTest ( TabEndnoten )
    '/// Close dialog ///
    TabEndnoten.Cancel
    Call hCloseDocument
    '/// Close active document ///
endcase

' -------------------------------------------

testcase tToolsGallery
    Dim i as integer
    printlog "- Tools / Gallery"
    Call hNewDocument
    '/// Open new document ///
    ToolsGallery
    '/// Tools / Gallery ///
    Sleep 3
    Kontext "Gallery"
    '/// Gallery has to be opened ///
    if Not Gallery.Exists then
        Warnlog "Gallery has not been opened! No test"
        goto endsub
    else
        '/// Step through all themes ///
        printlog "- Step through all Themes"
        For i = 1 to Gallerys.GetItemCount
            Gallerys.Select i
            Wait 500
        next i
        printlog "- New theme"
    endif

    Kontext
    ToolsGallery
    '/// Close gallery with Tools / Gallery ///
    Kontext "Gallery"
    if Gallery.Exists then Warnlog "Gallery has not been closed!"

    Call hCloseDocument
    '/// Close active document ///

endcase

' -------------------------------------------

testcase tToolsBibliographyDatabase
    printlog "- Tools / Bibliography Database "
    '/// Tools / Bibliography Database ///
    ToolsBibliographyDatabase
    Sleep 2
    Kontext "TB_Bibliography"
    try
        '/// Click 'Column Arrangement' ///
        ColumnArrangement.Click
        Sleep 1
        Kontext "Spaltenzuordnung"
        if Spaltenzuordnung.Exists then
            Call DialogTest ( Spaltenzuordnung )
            Spaltenzuordnung.Cancel
        else
            Warnlog "Dialog 'Column Layout' has not been opened!"
        endif
    catch
        Warnlog "Unable to click 'Column Arangement'!"
    endcatch

    Kontext "TB_Bibliography"
    try
        DataSource.Click
        '/// Click 'Data Source' ///
        Sleep 1
        Kontext "DatenquelleLiteraturdatenbank"
        if DatenquelleLiteraturdatenbank.Exists then
            Call DialogTest ( DatenquelleLiteraturdatenbank )
            DatenquelleLiteraturdatenbank.ok
        else
            Warnlog "Dialog 'Data Source' has not been opened!"
        endif
    catch
        Warnlog "Unable to click 'Data Source'!"
    endcatch

    Kontext "Bibliography"
    try
        'Works only in testtool srx643 or greater
        '/// Close 'Bibliography Database' ///
        DatabaseClose
    catch
        Warnlog "Unable to close Bibliography dialog!"
    endcatch
endcase

' -------------------------------------------

testcase tToolsDataSources
    printlog "Tools / Data Sources"
    Call hNewDocument
    '/// Open new document ///
    ToolsDataSources
    '/// Tools / Data Sources ///
    Kontext "DataSourceAdministration"
    TabControl.SetPage TabGeneral
    Kontext "TabGeneral"
    'Call DialogTest ( TabGeneral )

    Kontext "DataSourceAdministration"
    try
        TabControl.SetPage TabdBase
        Kontext "TabdBase"
        'Call DialogTest ( TabdBase )
    catch
    endcatch
    '/// Step through all tabpages ///

    Kontext "DataSourceAdministration"
    TabControl.SetPage TabTables
    Kontext "TabTables"
    'Call DialogTest ( TabTables )

    Kontext "DataSourceAdministration"
    TabControl.SetPage TabQueries
    Kontext "TabQueries"
    'Call DialogTest ( TabQueries )

    Kontext "DataSourceAdministration"
    DataSourceAdministration.Close
    '/// Close 'Data Source Administration' ///

    Call hCloseDocument
    '/// Close active document ///
endcase

' -------------------------------------------

testcase tToolsMailMerge
    Dim i as integer

    PrintLog "- Tools / Mail Merge"
    if gApplication = "HTMLDOKUMENT" then goto endsub
    Call hNewDocument
    '/// Open new document ///
    ToolsMailMerge
    '/// Tools / Mail Merge ///
    Kontext "MailMerge"
    Call DialogTest ( MailMerge )
    Wait 500
    '/// Check 'Use Template' and click 'OK' ///
    UseTemplate.Check
    MailMerge.Ok
    '/// The 'Template and Documents' dialog should be up ///
    For i = 1 to 100
        Kontext "TemplateAndDocuments"
        if TemplateAndDocuments.Exists = TRUE then
            i = 200
        endif
        Sleep 1
    Next i
    if i = 200 then
        Warnlog "Dialog 'Template and Documents' is not up !"
    else
        Call DialogTest ( TemplateAndDocuments )
        TemplateAndDocuments.Cancel
    endif
    '/// Tools / Mail Merge ///
    ToolsMailMerge
    Kontext "MailMerge"
    '/// Select 'This Document' and click 'OK' ///
    ThisDocument.Check
    MailMerge.Ok
    wait 500
    '/// Whether a messagebox to establish Data-connection appears .... ///
    Kontext "DataSourcesNotAvailable"
    if DataSourcesNotAvailable.Exists then
        Call DialogTest ( DataSourcesNotAvailable )
        DataSourcesNotAvailable.Ok
        Sleep 5
        '/// ... then the Address Source Autopilot has to come up, or ... ///
        Kontext "AddressSourceAutopilot"
        if AddressSourceAutopilot.Exists then
            AddressSourceAutopilot.Cancel
            Kontext "MailMergeInsertFields"
            if MailMergeInsertFields.Exists then MailMergeInsertFields.Cancel
        else
            Warnlog "AddressSourceAutopilot not up!"
        endif
    else
        Kontext "MailMergeInsertFields"
        '/// .. a messagebox appears asking to select a data source ///
        if MailMergeInsertFields.Exists then
            Call DialogTest ( MailMergeInsertFields )
            MailMergeInsertFields.Ok
            Kontext "TabDatenbank"
            if TabDatenbank.Exists then
                TabDatenbank.Cancel
            else
                Warnlog "Dialog to select database not up !"
            endif
        else
            Warnlog "No reaction after Mail Merge dialog !"
        endif
    endif
    '/// Close active document ///
    Call hCloseDocument

endcase

' -------------------------------------------

testcase tToolsTextInTables
    PrintLog "- Tools / Text <-> Tables"

    Call hNewDocument
    '/// Open new document ///
    Call wDokSchreiben ("Hallo dieser Text soll in eine Tabelle")
    '/// Insert some text and select it ///
    Call wDokSchreiben ("<Shift Home>")
    ToolsTextInTable
    '/// Tools / Text<->Table ///
    Kontext "TextInTabelleUmwandeln"
    DialogTest ( TextInTabelleUmwandeln )
    TextInTabelleUmwandeln.Cancel
    '/// Close upcoming dialog ///
    Call hCloseDocument
    '/// Close active document ///

endcase

' -------------------------------------------

testcase tToolsSort
    Dim i as integer
    PrintLog "- Tools / Sort"

    Call hNewDocument
    '/// Open new document ///
    For i = 1 to 5
        Call wDokSchreiben (i)
        Call wDokSchreiben ("<Return>")
    next i
    Call wDokSchreiben ("<Mod1 A>")
    ToolsSort
    Kontext "Sortieren"
    Call DialogTest ( Sortieren )
    Sortieren.Cancel
    Call hCloseDocument
    '/// Close active document ///

endcase

' -------------------------------------------

testcase tToolsCalculate
    PrintLog "- Tools / Calculate"

    Call hNewDocument
    '/// Open new document ///
    Call wDokSchreiben( "2+4" )
    '/// Insert text: 2+4 ///
    EditSelectAll
    '/// Edit / Select All ///
    ToolsCalculate
    '/// Tools / Calculate ///
    Call wDokSchreiben ("<End>  Das Ergebnis ist = ")
    '/// Paste result of calculation with Edit / Paste ///
    EditPaste
    Call hCloseDocument
    '/// Close active document ///

endcase

' -------------------------------------------

testcase tToolsUpdate
    PrintLog "- Tools / Update"
    if gApplication = "HTMLDOKUMENT" then
        printlog "Not in WriterWeb !"
        goto endsub
    endif
    Call hNewDocument
    '/// Open new document ///

    printlog "  - Update Indexes ( all, current )"
    '/// Add a text to document ///
    Call wDokSchreiben ("Dieser Text ist zur Aktualisierung")
    InsertIndexes
    '/// Insert / Indexes ///
    Sleep 2
    Kontext "Active"
    if Active.Exists then
        if active.GetRT = 304 then
            Warnlog Active.Gettext
            Active.Ok
        endif
    endif
    Sleep 2
    Kontext
    Active.Setpage TabVerzeichnisseVerzeichnis
    Kontext "TabVerzeichnisseVerzeichnis"
    TabVerzeichnisseVerzeichnis.OK
    '/// Close upcoming Index dialog ///
    Sleep 1
    '/// Tools / Update / All Indexes ///
    ToolsUpdateAllIndexes
    Sleep 1
    '/// Tools / Update / Current Index ///
    ToolsUpdateCurrentIndex

    printlog "  - Update Fields"
    Call wDokSchreiben ("<Up><Home><Tab>")
    '/// Insert / Fields / Author ///

    InsertFieldsAuthor
    '/// Insert / Fields / Time ///
    InsertFieldsTime
    Sleep 1
    ToolsUpdateFields
    '/// Tools / Update / Fields ///

    printlog "  - Update links"
    '/// Insert a graphic from file ///
    Call hGrafikVerknuepftEinfuegen ( gTesttoolPath + "writer\input\grafik\jolink.jpg" )
    try
        '/// Tools / Update / Links ///
        ToolsUpdateLinks
    catch
        Warnlog "Links can't be updated!"
    endcatch

    printlog "  - Update / Reformat Pages"
    '/// Tools / Page formatting ///
    ToolsPageFormatting

    printlog "  - update all"
    '/// Tools / Update / Update All ///
    ToolsUpdateUpdateAll

    Call hCloseDocument
    '/// Close active document ///
endcase

' -------------------------------------------

testcase tToolsMacro
    PrintLog "- Tools / Macro"

    Call hNewDocument
    '/// Open new document ///
    ToolsMacro
    '/// Tools / Macro ///
    Kontext "Makro"
    '/// On upcoming dialog step through all tabpages ///
    Call DialogTest ( Makro )
    Verwalten.Click

    Kontext
    active.SetPage TabModule
    Kontext "TabModule"
    Call DialogTest ( TabModule )

    Kontext
    active.SetPage TabBibliotheken
    Kontext "TabBibliotheken"
    Call DialogTest ( TabBibliotheken )
    if gUseSysDlg = False then
        Hinzufuegen.Click

        Kontext "Active"
        if Active.Exists then
            Warnlog Active.Gettext
            Active.Ok
        endif

        Kontext "OeffnenDlg"
        OeffnenDlg.Cancel
    endif

    Kontext "TabBibliotheken"
    TabBibliotheken.Close
    '/// Close 'Macro' dialog ///

    Kontext "Makro"
    Makro.Cancel
    Call hCloseDocument
    '/// Close active document ///

endcase

' -------------------------------------------

testcase tToolsConfigure
    PrintLog "- Tools / Configure"

    Call hNewDocument
    '/// Open new document ///
    ToolsConfigure
    '/// Tools / Configure ///

    Kontext
    active.SetPage TabMenu
    Kontext "TabMenu"
    Call DialogTest ( TabMenu )
    '/// On upcoming dialog step through all tabpages ///

    if gUseSysDlg = False then
        Laden.Click
        Kontext "OeffnenDlg"
        wait 500
        Call DialogTest ( OeffnenDlg )
        OeffnenDlg.Cancel

        Kontext "TabMenu"
        wait 500
        Speichern.Click
        Kontext "SpeichernDlg"
        wait 500
        Call DialogTest ( SpeichernDlg )
        SpeichernDlg.Cancel
    endif

    wait 500
    Kontext
    active.SetPage TabTastatur
    Kontext "TabTastatur"
    Call DialogTest ( TabTastatur )
    if gUseSysDlg = False then
        Laden.Click
        Kontext "OeffnenDlg"
        wait 500
        Call DialogTest ( OeffnenDlg )
        OeffnenDlg.Cancel
        Kontext "TabTastatur"
        wait 500
        Speichern.Click
        Kontext "SpeichernDlg"
        wait 500
        Call DialogTest ( SpeichernDlg )
        SpeichernDlg.Cancel
    endif

    Kontext
    active.SetPage TabStatusleiste
    Kontext "TabStatusleiste"
    wait 500
    Call DialogTest ( TabStatusleiste )
    if gUSeSysDlg = False then
        Laden.Click
        Kontext "OeffnenDlg"
        wait 500
        Call DialogTest ( OeffnenDlg )
        OeffnenDlg.Cancel

         Kontext "TabStatusleiste"
         Speichern.Click
        Kontext "SpeichernDlg"
        wait 500
        Call DialogTest ( SpeichernDlg )
        SpeichernDlg.Cancel
    endif

    Kontext
    active.SetPage TabSymbolleisten
    Kontext "TabSymbolleisten"
    wait 500
    Call DialogTest ( TabSymbolleisten )
    if gUseSysDlg = False then
        Laden.Click
        Kontext "OeffnenDlg"
        wait 500
        Call DialogTest ( OeffnenDlg )
        OeffnenDlg.Cancel
        Kontext "TabSymbolleisten"
        wait 500
        Speichern.Click
        Kontext "SpeichernDlg"
        wait 500
        Call DialogTest ( SpeichernDlg )
        SpeichernDlg.Cancel
    endif

    Kontext
    active.SetPage TabEreignisse
    Kontext "TabEreignisse"
    Call DialogTest ( TabEreignisse )

    Kontext
    active.SetPage TabSymbolleisten
    Kontext "TabSymbolleisten"
    Call DialogTest ( TabSymbolleisten )
    Bearbeiten.Click
    Sleep 1
    Kontext "CustomizeToolbars"
    CustomizeToolbars.Close
    '/// Close 'Customize' dialog ///

    Call hCloseDocument
    '/// Close active document ///

endcase
