'*************************************************************************
'*
'*  $RCSfile: w_020_.inc,v $
'*
'*  $Revision: 1.3 $
'*
'*  last change: $Author: hde $ $Date: 2003/12/22 14:14:10 $
'*
'*  The Contents of this file are made available subject to the terms of
'*  either of the following licenses
'*
'*         - GNU Lesser General Public License Version 2.1
'*         - Sun Industry Standards Source License Version 1.1
'*
'*  Sun Microsystems Inc., October, 2000
'*
'*  GNU Lesser General Public License Version 2.1
'*  =============================================
'*  Copyright 2000 by Sun Microsystems, Inc.
'*  901 San Antonio Road, Palo Alto, CA 94303, USA
'*
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License version 2.1, as published by the Free Software Foundation.
'*
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
'*  MA  02111-1307  USA
'*
'*
'*  Sun Industry Standards Source License Version 1.1
'*  =================================================
'*  The contents of this file are subject to the Sun Industry Standards
'*  Source License Version 1.1 (the License); You may not use this file
'*  except in compliance with the License. You may obtain a copy of the
'*  License at http://www.openoffice.org/license.html.
'*
'*  Software provided under this License is provided on an AS IS basis,
'*  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
'*  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
'*  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
'*  See the License for the specific provisions governing your rights and
'*  obligations concerning the Software.
'*
'*  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
'*
'*  Copyright: 2000 by Sun Microsystems, Inc.
'*
'*  All Rights Reserved.
'*
'*  Contributor(s): _______________________________________
'*
'*
'/******************************************************************
'*                                                                **
'* owner : helge.delfs@sun.com                                    **
'*                                                                **
'* short description :                                            **
'*                                                                **
'\******************************************************************

sub w_020_
    printLog Chr(13) + "--------- Toolbars (w_020_.inc) ----------"

'   ** Toolbar
    Call t_TB_Insert
    Call t_TB_InsertFields
    Call t_TB_InsertObjects
    Call t_TB_ShowDrawFunctions
    Call t_TB_Form
    Call t_TB_EditAutotext
    Call t_TB_Spellcheck
    Call t_TB_Graphics
    Call t_TB_DirektCursor
    Call t_TB_Find
    Call t_TB_Rest

end sub

'-----------------------------------------------------------

testcase t_TB_Insert
    printlog "- Toolbox ( normal ) : All within Insert"

    Call hNewDocument
    '/// Open new document ///
    printlog "- TearOff Insert-Toolbox"
    if gApplication <> "HTMLDOKUMENT" then
        Kontext "WL_SW"
        '/// Tear off 'Insert' Toolbox ///
        Einfuegen.TearOff
        Kontext "TB_SW_Einfuegen"
        TB_SW_Einfuegen.Move ( 20, 20 )
        printlog "  - Frame"
        '/// Click 'Frame' and Insert a Frame ///
        Rahmen.Click
        Call gMouseMove(40, 40, 60, 60)
        Call wDokSchreiben ("<Delete>")
        '/// Hit 'Delete' to remove the frame ///
    else
        Kontext "WL_Web"
        Einfuegen.TearOff
        Kontext "TB_SW_Einfuegen"
        TB_SW_Einfuegen.Move ( 20, 20 )
    endif

    printlog "  - Graphic"
    Kontext "TB_SW_Einfuegen"
    if gUSeSysDlg = False then
        '/// Click 'Insert Graphics' in Toolbox ///
        Grafik.Click
        Kontext "GrafikEinfuegenDlg"
        if GrafikEinfuegenDlg.Exists then
            Dateiname.SetText ( ConvertPath ( gTesttoolPath + "writer\input\grafik\jolink.jpg" ) )
            '/// Select graphic from file '..\writer\input\grafik\jolink.jpg' ///
            Oeffnen.Click
        else
            Warnlog "Dialog 'Insert Graphic' not up!"
        endif
        Sleep 1
        Kontext "Active"
        if Active.Exists then
            Warnlog Active.Gettext
            Active.Ok
            Kontext "GrafikEinfuegenDlg"
            GrafikEinfuegenDlg.Cancel
        endif
        Call wDokSchreiben ("<Delete>")
        '/// Hit 'Delete' to remove graphic ///
    endif

    Sleep 2
    printlog "  - Table"
    Kontext "TB_SW_Einfuegen"
    '/// Click 'Insert Table' in Toolbox ///
    Tabelle.CLick
    Kontext "TabelleEinfuegenWriter"
    TabelleEinfuegenWriter.OK
    '/// Move cursor under table ///
    Call wDokSchreiben ("<Down>",2)

    printlog "  - Document"
    Kontext "TB_SW_Einfuegen"
    if gUseSysDlg = False then
        '/// Click 'Document' in toolbar ///
        DateiEinfuegen.CLick
        Kontext "OeffnenDlg"
        Sleep 1
        OeffnenDlg.Cancel
        '/// Cancel upcoming File-Open dialog ///
    endif

    if gApplication <> "HTMLDOKUMENT" then
        printlog "  - Footnote"
        Kontext "TB_SW_Einfuegen"
        Fussnote.CLick
        '/// Click 'Insert Footnote Directly' in Toolbox ///
        Call wDokSchreiben ("<PageUp>")
        Sleep 2
        printlog "  - Endnote"
        Kontext "TB_SW_Einfuegen"
        '/// Click 'Insert Endnote Directly' in Toolbox ///
        Endnote.CLick
        Call wDokSchreiben ("<PageUp>")
        printlog "  - Index Marker"
        Call wDokSchreiben ("Index Marker <Shift Home>")
        Kontext "TB_SW_Einfuegen"
        '/// Click 'Insert Index Marker' in Toolbox ///
        Verzeichnis.CLick
        Kontext "VerzeichniseintragEinfuegen"
        VerzeichniseintragEinfuegen.Close
        '/// Close upcoming 'Insert Index Entry' dialog ///
    endif

    printlog "  - Special Character"
    Kontext "TB_SW_Einfuegen"
    Sonderzeichen_.CLick
    Kontext "Sonderzeichen"
    '/// Click 'Insert Special Character' in Toolbox ///
    Sonderzeichen.Cancel
    '/// Cancel upcoming 'Special Character' dialog ///

    printlog "  - Insert Section"
    Kontext "TB_SW_Einfuegen"
    BereichEinfuegen.Click
    '/// Click 'Insert Section' in Toolbox ///
    Kontext
    Active.Setpage TabBereiche
    Kontext "TabBereiche"
    TabBereiche.Ok
    '/// Close upcoming 'Section' dialog ///

    printlog "  - Bookmark"
    Kontext "TB_SW_Einfuegen"
    Textmarke.CLick
    '/// Click 'Insert Bookmark' in Toolbox ///
    Kontext "TextmarkeEinfuegen"
    Textmarken.SetText "Bookmark"
    '/// Enter a bookmark name and close dialog ///
    TextmarkeEinfuegen.OK

    Kontext "TB_SW_Einfuegen"           ' nur durch Schlieen der Toolbox ist der Dialog ansprechbar
    if TB_SW_Einfuegen.Exists then TB_SW_Einfuegen.Close
    '/// Close toolbar ///

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase t_TB_InsertFields
    Dim Ende, i as Integer
    printlog "- Toolbox ( normal ) : Fields"

    Call hNewDocument
    '/// Open new document ///
    printlog "- TearOff Insert Toolbox"
    '/// Click 'Insert Fields' in toolbar ///
    Kontext "WL_SW"
    Feldbefehle.Click
    Kontext
    Active.SetPage TabDokumentFeldbefehle
    Kontext "TabDokumentFeldbefehle"
    '/// Cancel upcoming 'Fields' dialog ///
    TabDokumentFeldbefehle.Cancel
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase t_TB_InsertObjects
    printlog "- Toolbox ( normal ) : Insert Objects"
    if gApplication = "HTMLDOKUMENT" then
        printlog "Not in WriterWeb!"
        goto endsub
    endif
    Call hNewDocument
    '/// Open new document ///
    Kontext "WL_SW"
    printlog "- TearOff Toolbox 'Objects'"
    '/// Tear off 'Insert Object' toolbar ///
    ObjektEinfuegen.TearOff
    Kontext "TB_SW_ObjektEinfuegen"
    TB_SW_ObjektEinfuegen.Move ( 20, 20 )
    '/// Click 'Chart' in Toolbox ///
    Diagramm.Click

    printlog "  - Chart"
    Kontext "AutoformatDiagramm1"
    '/// Click 'Create' on Chart Autopilot ///
    Fertigstellen.Click
    Sleep (2)
    Call gMouseClick ( 10, 10 )
    'Call gMouseClick ( 10, 50 )

    printlog "  - Formula"
    Kontext "TB_SW_ObjektEinfuegen"
    '/// Click 'Insert Star Office Math Object' in toolbar ///
    Formel.Click
    Sleep (2)
    Kontext "Active"
    if Active.Exists then
        Warnlog Active.Gettext
        Active.Ok
    endif
    Sleep 2
    Call gMouseClick ( 10, 50 )
    Call gMouseClick ( 10, 50 )

    printlog "  - Frame"
    Kontext "TB_SW_ObjektEinfuegen"
    '/// Click 'Insert Floating Frame' in toolbar ///
    Rahmenfenster.Click
    Kontext "TabEigenschaften"
    FrameName.SetText "Floating Frame"
    '/// Insert a name and close dialog 'Floating Frame Properties' ///
    TabEigenschaften.OK
    Sleep (2)
    Call gMouseClick ( 10, 50 )
    Call gMouseClick ( 10, 50 )

    printlog "  - OLE-Object"
    Kontext "TB_SW_ObjektEinfuegen"
    OLEObjekt.Click
    '/// Click 'Insert OLE Object' in toolbar ///
    Kontext "OLEObjektEinfuegen"
    OLEObjektEinfuegen.OK
    '/// Close upcoming 'OLE Object' dialog ///
    Sleep (2)
    Kontext "Messagebox"
    if Messagebox.Exists then
        Warnlog Messagebox.GetText
        Messagebox.OK
        Sleep 2
        AppAbort
    end if
    if Messagebox.Exists then
        Messagebox.OK
    end if
    Call gMouseClick ( 10, 50 )
    Call gMouseClick ( 10, 50 )
    Kontext "TB_SW_ObjektEinfuegen"
    printlog "   - Plug-In"
    Plugin.Click
    '/// Click 'Insert Plug-In' in toolbar ///
    Sleep 2
    Kontext "PlugInEinfuegen"
    if PlugInEinfuegen.Exists then
        PlugInEinfuegen.Cancel
    else
        Warnlog "Dialog 'Insert Plug-In' not up !"
    endif
    '/// Cancel upcoming 'Insert Plug-In' dialog ///

    Kontext "TB_SW_ObjektEinfuegen"
    printlog "   - Applet"
    Applet.Click
    '/// Click 'Insert Applet' in toolbar ///
    Sleep 2
    Kontext "AppletEinfuegen"
    if AppletEinfuegen.Exists then
        AppletEinfuegen.Cancel
        Sleep 5
    else
        Warnlog "Dialog 'Insert Applet' not up !"
    endif
    '/// Cancel upcoming 'Insert Applet' dialog ///

    Kontext "TB_SW_ObjektEinfuegen"
    if TB_SW_ObjektEinfuegen.Exists then TB_SW_ObjektEinfuegen.Close
    '/// Close toolbar ///

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase t_TB_ShowDrawFunctions
    printlog "- Toolbox ( normal ) : Draw Functions"
    if gApplication = "HTMLDOKUMENT" then
        printlog "Not in WriterWeb!"
        goto endsub
    endif

    Call hNewDocument
    '/// Open new document ///
    ViewZoom
    Kontext "Massstab"
    Optimal.Check
    Massstab.OK

    Kontext "WL_SW"
    printlog "- TearOff Draw Functions"
    try
        Zeichnen.TearOff
    catch
        Warnlog "Unable to Tear Off 'Draw Functions' Toolbox"
        Call hCloseDocument
        goto endsub
    endcatch

    '/// Tear off 'Draw functions' toolbar ///
    Sleep 2
    Kontext "TB_Zeichenfunktionen"
    TB_Zeichenfunktionen.Move ( 10, 10 )
    Sleep 5

    printlog "  - Draw Line"
    Kontext "TB_Zeichenfunktionen"
    '/// Draw a Line ///
    try
        Linie.Click
        Call gMouseMove(20, 20, 30, 30)
        Call wDokSchreiben ("<Escape>")
    catch
        Warnlog " Line could not be created !"
    endcatch

    printlog "  - Draw Rectangle"
    Kontext "TB_Zeichenfunktionen"
    '/// Draw a Rectangle ///
    Rechteck.Click
    Call gMouseMove(31, 20, 40, 40)
    Call wDokSchreiben ("<Escape>")

    printlog "  - Draw Ellipse"
    Kontext "TB_Zeichenfunktionen"
    '/// Draw an Ellipse ///
    Ellipse.Click
    Call gMouseMove(31, 30, 60, 50)
    Call wDokSchreiben ("<Escape>")

    printlog "  - Draw Polygon"
    Kontext "TB_Zeichenfunktionen"
    '/// Draw a Polygon ///
    Polygon.Click

    Call gMouseMove ( 22, 28, 35, 39 )
    Call gMouseClick ( 30, 55 )
    Call gMouseDoubleClick ( 55, 70 )
    Call wDokSchreiben ("<Escape>")

    printlog "  - Draw Bezier"
    Kontext "TB_Zeichenfunktionen"
    '/// Draw a Bezier ///
    Bezier.Click
    Call gMouseMove( 23, 30, 35, 43 )
    Call gMouseClick(30, 60)
    Call gMouseDoubleClick ( 55, 70 )
    Call wDokSchreiben ("<Escape>")

    printlog "  - Draw Freeform"
    Kontext "TB_Zeichenfunktionen"
    Freihand.Click
    '/// Draw a Freeform ///
    Call gMouseMove ( 23, 20, 35, 31 )
    Call gMouseMove ( 35, 31, 40, 90 )
    Call gMouseMove ( 41, 91, 55 , 70 )
    Call gMouseClick( 55, 70 )
    Call wDokSchreiben ("<Escape>")

    printlog "  - Draw Circle"
    Kontext "TB_Zeichenfunktionen"
    '/// Draw a Circle ///
    Kreisbogen.Click
    Call gMouseMove ( 20, 20, 50, 70 )
    Call gMouseClick ( 50, 30 )
    Call gMouseClick ( 50, 65 )
    Call wDokSchreiben ("<Escape>")

    printlog "  - Draw Arc"
    Kontext "TB_Zeichenfunktionen"
    Kreissektor.Click
    '/// Draw an Arc ///
    Call gMouseMove (80 ,80 ,50 ,30 )
    Call gMouseClick ( 50, 70 )
    Call gMouseClick ( 50, 70, 50, 50 )
    Call gMouseClick ( 50, 50 )
    Call wDokSchreiben ("<Escape>")

    printlog "  - Draw Circle Segment"
    Kontext "TB_Zeichenfunktionen"
    '/// Draw a Circle Element ///
    Kreissegment.Click
    Call gMouseMove ( 40, 20, 70 ,80 )
    Call gMouseClick ( 70, 70 )
    Call gMouseClick ( 40, 50 )
    Call wDokSchreiben ("<Escape>")

    printlog "  - Draw Textobject"
    Kontext "TB_Zeichenfunktionen"
    '/// Draw a Textobject ///
    Textobjekt.Click
    Call gMouseMove ( 17, 17, 28, 25 )
    Call wDokSchreiben ("Textobject")
    Call gMouseClick ( 50, 99 )
    Call wDokSchreiben ("<Escape>")

    printlog "  - Draw Text Animation"
    Kontext "TB_Zeichenfunktionen"
    '/// Insert a Text Animation ///
    Lauftext.Click
    Call gMouseMove  (37, 37, 48, 45 )
    Call gMouseClick ( 48, 45 )
    Call wDokSchreiben ("Text Animation")
    Call gMouseClick ( 50, 99 )
    Call wDokSchreiben ("<Escape>")

    printlog "  - Draw Callouts"
    Kontext "TB_Zeichenfunktionen"
    '/// Draw a Callout ///
    Legende.Click
    Call gMouseMove (15, 20, 50, 60)
    Call gMouseClick( 50, 60 )
    Call wDokSchreiben ("<Escape>")

    Kontext "TB_Zeichenfunktionen"
    TB_Zeichenfunktionen.Close
    '/// Close toolbar 'Draw Functions' ///
    ViewZoom
    Kontext "Massstab"
    Vergroesserung100.Check
    Massstab.OK

    Call hCloseDocument
    '/// Close active document ///

endcase

'-----------------------------------------------------------

testcase t_TB_Form
    printlog "- Toolbox ( normal ) : Formular"

    Call hNewDocument
    '/// Open new document ///
    Sleep 1
    try
        Kontext "WL_SW"
        Formular.TearOff
        '/// Tear off 'Form' Toolbox ///
        Kontext "TB_Formularfunktionen"
        TB_Formularfunktionen.Move 20, 30

        Pushbutton.Click
        '/// Insert a pushbutton from toolbox ///
        Call hMalZeichnenMitSelektion ( 10, 20, 20, 25 )
        Sleep 2
        Kontext "TB_Formularfunktionen"
        _ControlEigenschaften.Click
        Sleep 2
        '///+ Open Control Properties ///
        printlog "   - Control Properties"
        Call sMenufunktionen("-Pushbutton-")

        Kontext "TB_Formularfunktionen"
        Radiobutton.Click
        '/// Insert a Radiobutton from toolbox ///
        Call hMalZeichnenMitSelektion ( 22, 20, 32, 25 )
        '///+ Open Control Properties ///
        Call sMenufunktionen("-Radiobutton-")

        Checkbox.Click
        '/// Insert a Checkbox from toolbox ///
        Call hMalZeichnenMitSelektion ( 35, 20, 45, 25 )
        '///+ Open Control Properties ///
        Call sMenufunktionen("-Checkbox-")

        Textbox.Click
        '/// Insert a textbox from toolbox ///
        Call hMalZeichnenMitSelektion ( 47, 20, 58, 25 )
        '///+ Open Control Properties ///
        Call sMenufunktionen("-Textbox-")

        printlog "Autopilot -Groupbox-"
        Groupbox.Click
        '/// Insert a groupbox from toolbox ///
        Call hMalZeichnenMitSelektion ( 10, 30, 20, 35 )
        Sleep 10
        '///+ Step through pages of upcoming Autopilot ///
        Call sAutopilot_Groupelement
        Kontext "Active"
        if Active.Exists then
            if Active.GetRT = 304 then
                Warnlog Active.Gettext
                Active.Ok
            else
                '///+ Open Control Properties ///
                Call sMenufunktionen(" Groupbox")
            endif
        else
            Call sMenufunktionen(" Groupbox")
        endif

        Sleep 3
        Kontext "TB_Formularfunktionen"
        '/// Insert an Edit Field from toolbox ///
        Edit.Click
        Wait 500
        Call hMalZeichnenMitSelektion ( 22, 30, 32, 35 )
        '///+ Open Control Properties ///
        Call sMenufunktionen("-Edit-")

        Listbox.Click
        Wait 500
        '/// Insert a listbox ///
        Call hMalZeichnenMitSelektion ( 35, 30, 45, 35 )
        '///+ Step through pages of upcoming Autopilot ///
        Call sAutopilot_ListboxCombobox("Listbox")
        '///+ Open Control Properties ///
        Call sMenufunktionen("-Listbox-")

        Combobox.Click
        '/// Insert a Combobox from toolbox ///
        Wait 500
        Call hMalZeichnenMitSelektion ( 47, 30, 58, 35 )
        '///+ Step through pages of upcoming Autopilot ///
        Call sAutopilot_ListboxCombobox("Combo")
        '///+ Open Control Properties ///
        Call sMenufunktionen("-Combobox-")

        GrafischeSchaltflaeche.Click
        '/// Insert an Image Button from toolbox ///
        Wait 500
        Call hMalZeichnenMitSelektion ( 10, 40, 20, 45 )
        '///+ Open Control Properties ///
        Call sMenufunktionen("-Image Button-")

        GrafischesKontrollfeld.Click
        '/// Insert an Image Control from toolbox ///
        Wait 500
        Call hMalZeichnenMitSelektion ( 22, 40, 32, 45 )
        '///+ Open Control Properties ///
        Call sMenufunktionen("-Image Control-")

        Dateiauswahl.Click
        '/// Insert File Selection from toolbox ///
        Wait 500
        Call hMalZeichnenMitSelektion ( 35, 40, 45, 45 )
        '///+ Open Control Properties ///
        Call sMenufunktionen("-File Selection-")

        try
            '/// Insert a Date Field from toolbox ///
            Datumsfeld.Click
            Wait 500
            Call hMalZeichnenMitSelektion ( 47, 40, 58, 45 )
            '///+ Open Control Properties ///
            Call sMenufunktionen("-Date Field-")
        catch
            Warnlog "'Data Field' not enabled!"
        endcatch

        try
            '/// Insert a Time Field from toolbox ///
            Zeitfeld.Click
            Wait 500
            Call hMalZeichnenMitSelektion ( 10, 50, 20, 55 )
            '///+ Open Control Properties ///
            Call sMenufunktionen("-Time Field-")
        catch
            Warnlog "'Time Field' not enabled!"
        endcatch

        try
            '/// Insert a Numerical Field from toolbox ///
            NumerischesFeld.Click
            Wait 500
            Call hMalZeichnenMitSelektion ( 22, 50, 32, 55 )
            '///+ Open Control Properties ///
            Call sMenufunktionen("-Numerical Field-")
        catch
            Warnlog "'Numerical Field' not enabled!"
        endcatch

        '/// Insert a Formatted Field from toolbox ///
        FormatiertesFeld.Click
        Wait 500
        Call hMalZeichnenMitSelektion ( 35, 50, 45, 55 )
        '///+ Open Control Properties ///
        Call sMenufunktionen("-Formatted Field-")

        '/// Insert a Currency Field from toolbox ///
        Waehrungsfeld.Click
        Wait 500
        Call hMalZeichnenMitSelektion ( 47, 50, 58, 55 )
        '///+ Open Control Properties ///
        Call sMenufunktionen("-Currency field-")

        '/// Insert a Pattern Field from toolbox ///
        MarkiertesFeld.Click
        Wait 500
        Call hMalZeichnenMitSelektion ( 10, 60, 20, 65 )
        '///+ Open Control Properties ///
        Call sMenufunktionen("-Pattern Field-")

        Kontext "ControlPropertiesDialog"
        if ControlPropertiesDialog.Exists then ControlPropertiesDialog.Close
        Kontext "TB_Formularfunktionen"
        '/// Insert a Table Control from toolbox ///
        TabellenControl.Click
        Wait 500
        Call hMalZeichnenMitSelektion ( 22, 60, 32, 65 )
        Sleep 10
        '///+ Step through pages of upcoming Autopilot ///
        Call sAutopilotTableElement

        Sleep 3
        '/// Click 'Control Properties' ///
        Kontext "TB_Formularfunktionen"
        _FormularEigenschaften.Click
        '///+ Close Properties Dialog ///
        Kontext "ControlPropertiesDialog"
        ControlPropertiesDialog.Close
        Kontext "TB_Formularfunktionen"
        '/// Click 'Form Properties' ///
        _FormularEigenschaften.Click
        Kontext "ControlPropertiesDialog"
        '///+ In 'Form Properties' step through all tabpages  ///
        ControlPropertiesControl.SetPage ControlPropertiesGeneral
        Kontext "ControlPropertiesGeneral"
        Sleep 1
        'Call DialogTest2 ( ControlPropertiesGeneral, 1 )
        Kontext "ControlPropertiesDialog"
        ControlPropertiesControl.SetPage ControlPropertiesData
        Kontext "ControlPropertiesData"
        Sleep 1
        'Call DialogTest2 ( ControlPropertiesData, 2 )
        Kontext "ControlPropertiesDialog"
        ControlPropertiesControl.SetPage ControlPropertiesEvents
        Kontext "ControlPropertiesEvents"
        Sleep 1
        'Call DialogTest2 ( ControlPropertiesEvents, 3 )
        Kontext "ControlPropertiesDialog"
        '///+ Close 'Form Properties' dialog  ///
        ControlPropertiesDialog.Close

        Call gMouseClick ( 40, 80 )
        Kontext "TB_Formularfunktionen"
        '/// Click 'Activation Order' in Toolbox ///
        _Aktivierungsreihenfolge.Click
        Kontext "Aktivierungsreihenfolge"
        Printlog "-Tab Order - Dialog"
        Call DialogTest ( Aktivierungsreihenfolge )

        if IndexGroesser.IsEnabled then
            '///+ In 'Tab Order' Dialog click 'Move Up' ///
            IndexGroesser.Click
            printlog "  - Move Up"
        else
            printlog "- Move Up is not activated!"
        endif

        if IndexKleiner.IsEnabled then
            '///+ In 'Tab Order' Dialog click 'Move Down' ///
            IndexKleiner.Click
            printlog "  - Move Down"
        else
            printlog "- Move Down is not activated!"
        endif

        if AutoSortierung.IsEnabled then
            '///+ In 'Tab Order' Dialog click 'Automatic Sort' ///
            AutoSortierung.Click
            printlog "  - Automatic Sort"
        else
            printlog "- Automatic Sort is not activated!"
        endif
        '///+ Close 'Tab Order' dialog  ///
        Aktivierungsreihenfolge.Cancel

        Kontext "TB_Formularfunktionen"
        '/// Click 'Add Field' in Toolbox ///
        FeldHinzufuegen.Click
        Kontext "Feldauswahl"
        Call DialogTest ( FeldAuswahl )
        '///+ Close 'Add Field' dialog ///
        Feldauswahl.Close
        printlog "   - Fields"

        Kontext "TB_Formularfunktionen"
        '/// Click 'Form Navigator' in Toolbox ///
        _FormularNavigator.Click
        Kontext "_FormularNavigator"
        Call DialogTest ( _FormularNavigator )
        '/// Close 'Form Navigator' ///
        _FormularNavigator.Close
        printlog "   - Form-Navigator"

        Kontext "TB_Formularfunktionen"
        '/// Click 'Design Mode' in Toolbox ///
        DesigneModus.Click
        Sleep 1
        '/// Click 'Design Mode' in Toolbox ///
        DesigneModus.Click
        printlog "   - Design mode"

    catch
        Exceptlog
    endcatch
    Kontext "TB_Formularfunktionen"

    if TB_Formularfunktionen.Exists then TB_Formularfunktionen.Close
    '/// Close 'form Functions' Toolbar ///

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase t_TB_EditAutotext
    printlog "- Toolbox ( normal ) : Autotext"

    Call hNewDocument
    '/// Open new document ///
    Kontext "WL_SW"
    Sleep 2
    Autotext_.Click
    '/// Click 'Autotext' in Toolbar ///
    wait 500
    Kontext "Active"
    if Active.Exists then
        Active.Gettext
        Active.Ok
    endif
    Sleep 5
    Kontext "Autotext"
    '/// Close upcoming 'Autotext' dialog ///
    Autotext.Close
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase t_TB_Spellcheck
    printlog "- Toolbox ( normal ) : Spellcheck"
    select case iSprache
        case 81 : Printlog "- No Spellcheck in Japanese!"
                  goto endsub
        case 82 : Printlog "- No Spellcheck in Korean!"
                  goto endsub
        case 86 : Printlog "- No Spellcheck in Chinese (simplified)!"
                  goto endsub
        case 88 : Printlog "- No Spellcheck in Chinese (traditional)!"
                  goto endsub
    end select

    Call hNewDocument
    '/// Open new document ///
    Call wDokSchreiben ("Spuelchecking<Return><Up>")
    '/// Write a wrong word to document ///
    Kontext "WL_SW"
    Rechtschreibung_.Click
    '/// Click 'Spellcheck' in Toolbar ///

    Kontext "Active"
    if Active.Exists then
        if Active.GetRT = 304 then
            try
                Active.yes
				Kontext "Active"
				if Active.Exists then
					if Active.GetRT = 304 then
						try
							Active.Ok
						catch
						endcatch
					endif
				endif	
            catch
                Active.Ok
            endcatch
        endif
    endif

    Kontext "Rechtschreibung"
    '/// Close 'Spellcheck' dialog ///
    if Rechtschreibung.Exists then Rechtschreibung.Close

    printlog "- Toolbox ( normal ) : AutoSpellcheck"
    Kontext "WL_SW"
    '/// Click 'Autospellcheck' in Toolbar ///
    AutomatischePruefung.Click
    Sleep 1
    '/// Click 'Autospellcheck' in Toolbar ///
    AutomatischePruefung.Click
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase t_TB_Find
    printlog "- Toolbox ( normal ) : Find & Replace"
    Call hNewDocument
    '/// Open new document ///
    Kontext "WL_SW"
    '/// Click 'Find' in Toolbar ///
    SuchenUndErsetzen.Click
    Kontext "SuchenUndErsetzenWriter"
    '/// Close 'Find&Replace' dialog ///
    SuchenUndErsetzenWriter.Close
    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase t_TB_Graphics
    printlog "- Toolbox ( normal ) : Graphic"

    Call hNewDocument
    '/// Open new document ///
    Call hGrafikEinfuegen ( gTesttoolpath + "writer\input\grafik\jolink.jpg" )
    '/// Insert graphic from file ..\writer\input\grafik\jolink.jpg ///

    Kontext "WL_SW"
    try
        '/// Click 'Graphic' in Toolbar ///
        GrafikenAusEin.Click
    catch
        Warnlog "Error on switching Graphic off!"
    endcatch
    Sleep 2
    try
        '/// Click 'Graphic' in Toolbar ///
        GrafikenAusEin.Click
    catch
        Warnlog "Error on switching Graphic on!"
    endcatch
    Sleep 2

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase t_TB_DirektCursor
    printlog "- Toolbox ( normal ) : Direct Cursor"
    if gApplication = "HTMLDOKUMENT" then
        printlog "Not in WriterWeb!"
        goto endsub
    endif

    Call hNewDocument
    '/// Open new document ///
    Kontext "WL_SW"
    '/// Click 'Direct Cursor' in Toolbar ///
    Direktcursor.Click
    Sleep 1
    Call gMouseDoubleClick(50, 70)
    '/// Point cursor somewhere in document ///
    Call wDokSchreiben ("Direct Cursor On")
    '/// Insert some words in document ///

    Kontext "WL_SW"
    '/// Click 'Direct Cursor' in Toolbar ///
    Direktcursor.Click
    Call gMouseDoubleClick (80, 20)
    '/// Insert some text in document ///
    Call wDokSchreiben ("Direct Cursor Off")

    Call hCloseDocument
    '/// Close active document ///
endcase

'-----------------------------------------------------------

testcase t_TB_Rest
    printlog "- Toolbox ( normal ) : Rest"

    Call hNewDocument
    '/// Open new document ///
    printlog "  - Hyperlink"
    if gApplication <> "HTMLDOKUMENT" then
        Kontext "WL_SW"
    else
        Kontext "WL_Web"
    endif
    try
        '/// Click 'Hyperlink' in Toolbar ///
        Hyperlink.Click
        Sleep 2
        '/// Click 'Hyperlink' in Toolbar ///
        Hyperlink.Click
        Warnlog "Button 'Hyperlink' should have been removed!"
    catch
    endcatch

    printlog "  - OnlineLayout"
    if gApplication <> "HTMLDOKUMENT" then
        Kontext "WL_SW"
        try
            '/// Click 'Online Layout' in Toolbar ///
            OnlineLayout.Click
            Sleep 2
            '/// Click 'Online Layout' in Toolbar ///
            OnlineLayout.Click
        catch
            Warnlog "Button 'OnlineLayout' is missing or disabled!"
        endcatch
    endif

    printlog "  - Nonprinting Characters"
    if gApplication <> "HTMLDOKUMENT" then
        Kontext "WL_SW"
    else
        Kontext "WL_Web"
    endif
    try
        '/// Click 'Nonprinting Characters' in Toolbar ///
        SteuerzeichenEinAus.Click
        Sleep 2
        '/// Click 'Nonprinting Characters' in Toolbar ///
        SteuerzeichenEinAus.Click
    catch
        Warnlog "Button 'Nonprinting Characters' is missing or disabled!"
    endcatch

    printlog "  - Graphics on/off"
    Kontext "WL_Web"
    try
        '/// Click 'Graphics' in Toolbar  ///
        GrafikenAusEin.Click
        Sleep 2
        '/// Click 'Graphics' in Toolbar  ///
        GrafikenAusEin.Click
    catch
        Warnlog "Button 'Graphics' is missing or disabled!"
    endcatch

    if gApplication = "HTMLDOKUMENT" then
        printlog "  - Print Layout on/off"
        Kontext "WL_Web"
        try
            '/// Click 'Print Layout' in Toolbar  ///
            DruckLayout.Click
            Sleep 2
            '/// Click 'Print Layout' in Toolbar  ///
            DruckLayout.Click
        catch
            Warnlog "Button 'Print Layout' is missing or disabled!"
        endcatch

        printlog "  - HTMLSource"
        try
            '/// Click 'HTML Source' in Toolbar  ///
            HTMLQuelltext.Click
            Sleep 2
            Kontext "SpeichernDlg"
            '/// Close 'FileOpen' dialog ///
            if SpeichernDlg.Exists then SpeichernDlg.Cancel
        catch
            Warnlog "Button 'HTML Source' is missing or disabled!"
        endcatch
    endif

    Call hCloseDocument
    '/// Close active document ///
endcase
